local FIX = CreateFrame("Frame");
FIX:SetScript("OnUpdate", function() IsDraggingCheck() end)

SimpleObjectivesMinimapButton:RegisterEvent("ADDON_LOADED")

DEFAULT_TEX_COORDS = { 0, 0, 0, 0.5, 0.5, 0, 0.5, 0.5 }
CLICK_TEX_COORDS = { 0.5, 0, 0.5, 0.5, 1.0, 0, 1.0, 0.5 }

MouseOverride = false
ObjectiveVisibility = true

function SimpleObjectivesMinimapButton:ADDON_LOADED(...)

	if SOData == nil or SOData.MapPos == nil or SOData.ObjectiveVisible == nil then
		SOData = { MapPos = 45, ObjectiveVisible = true }
	end
	MapPos = SOData.MapPos
	ObjectiveVisibility = SOData.ObjectiveVisible
	ToggleObjectives(true)
	SetDefaultTexture()
	Reposition()
end


function Reposition()
	SimpleObjectivesMinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(MapPos)),(80*sin(MapPos))-52)
end

function ToggleObjectives(startup)
	local objectFrame = ObjectiveTrackerFrame:IsShown()
	if startup == true then
		objectFrame = not ObjectiveVisibility
	end
	local chatMessage = ""
	
	if objectFrame then 
		chatMessage = "Objective Window: |cfff000f0Hidden"
		ObjectiveTrackerFrame:Hide() 
	else 
		chatMessage = "Objective Window: |cff00ff00Visible"
		ObjectiveTrackerFrame:Show() 
	end
	ObjectiveVisibility = ObjectiveTrackerFrame:IsShown()
	SOData.ObjectiveVisible = ObjectiveVisibility
	return chatMessage
end
function SimpleObjectivesMinimapButton_OnClick()
	PlaySound(SOUNDKIT.U_CHAT_SCROLL_BUTTON)
	RaidNotice_AddMessage(RaidWarningFrame, ToggleObjectives(false), ChatTypeInfo["RAID_WARNING"])
end
function SimpleObjectivesMinimapButton_OnMouseDown()
	MouseOverride = true;
	SetClickTexture()
end
function SimpleObjectivesMinimapButton_OnMouseUp()
	MouseOverride = false;
	SetDefaultTexture()
end
function SimpleObjectivesMinimapButton_OnLeave()
	MouseOverride = false;
	GameTooltip:Hide()
end

function SimpleObjectivesMinimapButton_OnEnter()
	GameTooltip:SetOwner(SimpleObjectivesMinimapButton_Icon, "ANCHOR_BOTTOMLEFT",0, 30)
	GameTooltip:SetText("|cffffffffSimple Objectives")
	GameTooltip:AddLine("|cff666666Left Click - |cff00ff00Toggle Objectives")
	GameTooltip:AddLine("|cff666666Right Click - |cff00ff00Move This")
	GameTooltip:Show()
end

function SetDefaultTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(DEFAULT_TEX_COORDS[1],DEFAULT_TEX_COORDS[2],DEFAULT_TEX_COORDS[3],DEFAULT_TEX_COORDS[4],DEFAULT_TEX_COORDS[5],DEFAULT_TEX_COORDS[6],DEFAULT_TEX_COORDS[7],DEFAULT_TEX_COORDS[8])
end

function SetClickTexture()
	SimpleObjectivesMinimapButton_Icon:SetTexCoord(CLICK_TEX_COORDS[1],CLICK_TEX_COORDS[2],CLICK_TEX_COORDS[3],CLICK_TEX_COORDS[4],CLICK_TEX_COORDS[5],CLICK_TEX_COORDS[6],CLICK_TEX_COORDS[7],CLICK_TEX_COORDS[8])
end

function IsDraggingCheck()
	if MouseOverride == true then
		SetClickTexture()
	elseif SimpleObjectivesMinimapButton_DraggingFrame:IsVisible() == false then
		SetDefaultTexture()
	else
		SetClickTexture()
	end
end


function SimpleObjectivesMinimapButton_DraggingFrame_OnUpdate()
	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()
	xpos = xmin-xpos/UIParent:GetScale()+70
	ypos = ypos/UIParent:GetScale()-ymin-70
	MapPos = math.deg(math.atan2(ypos,xpos))
	SOData = { MapPos = MapPos, ObjectiveVisible = ObjectiveVisibility }
	Reposition()
end

